function dropItem(sl_storage,sl_var,sl_output)
{
	var out = setArrayValItem(sl_storage,sl_var,-1,true);
	
    var p = GetPlayer();
	if (sl_output)
	{
	 p.SetVar(sl_output,out);	
	}
	return out;
}

function initItems(initText, sl_storage, sl_varnames)
{
    var p = GetPlayer();
	
	var st_content = initText.split("|");
	p.SetVar(sl_storage,initText);

	var target_content = sl_varnames.split("|");
    for (var i=0;i<st_content.length;i++)
{
	if (st_content[i])
	{
		if (target_content[i])
		{
			p.SetVar(target_content[i],st_content[i]);
		}
	}
}   
	
	
}

function compareItems(sl_storage,sl_compare,sl_inplace,sl_outplace)
{
	var inplace = 0;
	var cnt = 0;
    var p = GetPlayer();
	
	var st_content = p.GetVar(sl_storage);

	var target_content = p.GetVar(sl_compare);
   
	var arr_player = st_content.split("|");
	var arr_target = target_content.split("|");
	var arr_playerAll = Array();
	var arr_targetAll = Array();
var mycount = 0;
var distance = 0;
	
for (var i=0;i<arr_player.length;i++)
{
if (arr_player[i])
{	
var target = getArrayValItem(sl_compare,i);
//arr_targetAll[target]++;
var player = getArrayValItem(sl_storage,i);
//arr_playerAll[player]++;

if (player == target )
{
	
	inplace++;
	arr_targetAll.push(i+1);
	
}
else
{
	distance+= Math.abs(player-target); 
	mycount = countValue(sl_storage,target,arr_targetAll);
     
	

 if (mycount)
 {
	cnt+=1; 
 }
	
}

}
}

if (cnt<0) { cnt = 0;}

if (sl_inplace)
{
	p.SetVar(sl_inplace,inplace);
}
if (sl_outplace)
{
	p.SetVar(sl_outplace,cnt);
}


}


function countValue(sl_storage,sl_value,arr_taken)
{
	var p = GetPlayer();
	var content = p.GetVar(sl_storage);
	var arr_content = content.split("|");
	var count = _countInArray(arr_content,sl_value,arr_taken);
	
	return count;
}

function _countInArray(array, what,arr_taken) {
    var count = 0;
    
	for (var i = 0; i < array.length; i++) {
        
		
		if (parseInt(array[i]) === parseInt(what)) {
			
            if (arr_taken.indexOf(i+1)==-1)
			{
			count++;
			arr_taken.push(i+1);
			}
			
        }
    }

    return count;
}


function addItem(sl_storage,sl_var,sl_output)
{
	var out = setArrayValItem(sl_storage,sl_var,1,true);
    
	var p = GetPlayer();
	if (sl_output)
	{
	 p.SetVar(sl_output,out);	
	}
	return out;
}


function nextItem(sl_storage,sl_var,min_step,max_step,sl_output)
{
	var item = getArrayValItem(sl_storage,parseInt(sl_var));
	item++;
	if (item>max_step)
	{
		item = min_step;
	}
	var out = setItem(sl_storage,sl_var,item);
	var p = GetPlayer();
	
	if (sl_output)
	{
	 p.SetVar(sl_output,out);
	 
	}
	return out;
}

function prevItem(sl_storage,sl_var,min_step,max_step,sl_output)
{
	var item = getArrayValItem(sl_storage,parseInt(sl_var));
	item--;
	if (item<min_step)
	{
		item = max_step;
	}
	var out = setItem(sl_storage,sl_var,item);
	var p = GetPlayer();
	
	if (sl_output)
	{
	 p.SetVar(sl_output,out);
	 
	}
	return out;
}

function flipItem(sl_storage,sl_var,sl_output)
{
	var item = getArrayValItem(sl_storage,parseInt(sl_var));
	if (item>0)
	{
		item = 0;
	}
	else
	{
		item = 1;
	}
	var out = setItem(sl_storage,sl_var,item);
	var p = GetPlayer();
	
	if (sl_output)
	{
	 p.SetVar(sl_output,out);
	 
	}
	return out;
}

function setItem(sl_storage,sl_var,newval,sl_output)
{
	var out = setArrayValItem(sl_storage,sl_var,newval);
var p = GetPlayer();
	if (sl_output)
	{
	 p.SetVar(sl_output,out);	
	}
return out;	
}

function countItem(sl_storage,sl_var,sl_return)
{
var total = 0;
total = getArrayValItem(sl_storage,parseInt(sl_var));
var p = GetPlayer();
if (sl_return)
{	
p.SetVar(sl_return,total);
}
return total;
}

function countItems(sl_storage,sl_vars,sl_return)
{
	

var total = 0;
var p = GetPlayer();
var varx = sl_vars.split(",");

	
for (var i=0;i<varx.length;i++)
{
	
total+= getArrayValItem(sl_storage,parseInt(varx[i]));

}


if (sl_return)
{	
var p = GetPlayer();
p.SetVar(sl_return,total);
}

return total;
}

function countAllItems(sl_storage,sl_return)
{

var total = 0;
var p = GetPlayer();
var varcontent = p.GetVar(sl_storage);
var varx = varcontent.split("|");
for (var i=0;i<varx.length;i++)
{
total+= getArrayValItem(sl_storage,i);

}


if (sl_return)
{	
var p = GetPlayer();
p.SetVar(sl_return,total);
}

return total;
}

function countUniqueItems(sl_storage,sl_return)
{

var total = 0;
var p = GetPlayer();

var varx = p.GetVar(sl_storage).split("|");

for (var i=0;i<varx.length;i++)
{
if (getArrayValItem(sl_storage,i)>0)
{	
total++;
}
}
if (sl_return)
{
var p = GetPlayer();
p.SetVar(sl_return,total);
}
return total;
}


function setArrayValItem(arrayVar,item,value,mode)
{
var player = GetPlayer();
var actVal=player.GetVar(arrayVar);
var mArray=actVal.split("|");
var arrayLength = mArray.length;

if (mode==true)
{
mArray[item]=parseInt(mArray[item])+parseInt(value);
}
else
{
mArray[item]=parseInt(value);
}

var newArray="";
for (var i = 0; i < arrayLength; i++) {
    
   newArray+=mArray[i];
   if (i<arrayLength-1)
{
    newArray+="|";
}
}	
player.SetVar(arrayVar,newArray);

return mArray[item];
}


function getArrayValItem(arrayVar,item)
{
var ret = 0;
var player = GetPlayer();
var actVal=player.GetVar(arrayVar);
var mArray=actVal.split("|");
if (item<mArray.length)
{
	if (mArray[item])
	{	
	ret = parseInt(mArray[item]);
	
	}
		
}
	
return ret;
}

